lm.component('lmDialogHomebox', {
	templateUrl: 'comp/dialog/lmDialogHomebox.' + lmCacheTag + 'html',
	bindings: { lmParams: '<', lmDismiss: '&', lmDone: '&' },
	controller: function($http, serviceLimboMedia) {
		var ctrl = this;
	  
		ctrl.boxTypes = ['NEWS','BOOKMARKS','TODO','NOTE','IOT'];

		ctrl.box = {
				type: ctrl.boxTypes[0],
				bookmarkLabel: null,
				todoLabel: null,
				noteLabel: null,
				note: null,
				noteRows: 5,
				hideOwn: false,
				hideForeign: false
		};

		ctrl.bookmarkLabels = [];
		ctrl.todoLabels = [];
		ctrl.noteLabels = [];
		ctrl.notes = [];
	  
		ctrl.$onInit = function() {
			/* load data for selection */
			$http.get(lmBase.url + 'b/labels/all').then(
				function success(resp) {
					ctrl.bookmarkLabels = resp.data;
					if(resp.data.length > 0) ctrl.box.bookmarkLabel = resp.data[0];
				},
				serviceLimboMedia.handleHttpErrorNew
			);

			$http.get(lmBase.url + 't/labels/all').then(
				function success(resp) {
					ctrl.todoLabels = resp.data;
					if(resp.data.length > 0) ctrl.box.todoLabel = resp.data[0];
				},
				serviceLimboMedia.handleHttpErrorNew
			);

			$http.get(lmBase.url + 'n/labels/all').then(
				function success(resp) {
					ctrl.noteLabels = resp.data;
					if(resp.data.length > 0) ctrl.box.noteLabel = resp.data[0];
					ctrl.loadNotes();
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		}

		ctrl.loadNotes = function() {
			ctrl.notes.splice(0,ctrl.notes.length);
			if(ctrl.box.noteLabel != null) {
				var getparams = new Object();
				getparams.lid = ctrl.box.noteLabel.id;
				$http.get(lmBase.url + 'n/items/list',{params : getparams}).then(			
					function success(resp) {
						ctrl.notes = resp.data;
						if(resp.data.length > 0) ctrl.box.note = resp.data[0];
					},
					serviceLimboMedia.handleHttpErrorNew
				);
			}
		};
		
		/* create box */
		ctrl.createNewsBox = function() {
			var box = new Object();
			box.type = 'newsBox';
			box.name = 'LimboMedia News';
			ctrl.lmDone({result: box});
		};

		ctrl.createBookmarkBox = function() {
			if(ctrl.box.bookmarkLabel != null) {
				var box = new Object();
				box.type = 'bookmarkBox';
				box.name = ctrl.box.bookmarkLabel.name;
				box.labelID = ctrl.box.bookmarkLabel.id;
				ctrl.lmDone({result: box});
			}
		};
		
		ctrl.createTodoBox = function() {
			if(ctrl.box.todoLabel != null) {
				var box = new Object();
				box.type = 'todoBox';
				box.name = ctrl.box.todoLabel.name;
				box.labelID = ctrl.box.todoLabel.id;
				ctrl.lmDone({result: box});
			}
		};
		
		ctrl.createNoteBox = function() {
			if(ctrl.box.note != null) {
				var box = new Object();
				box.type = 'noteBox';
				box.name = ctrl.box.note.name;
				box.noteID = ctrl.box.note.id;
				box.rows = ctrl.box.noteRows;
				ctrl.lmDone({result: box});
			}
		};
		
		ctrl.createThingsBox = function() {
			var box = new Object();
			box.type = 'thingsBox';
			box.iname = 'IOT';
			box.hideOwn = ctrl.box.hideOwn;
			box.hideForeign = ctrl.box.hideForeign;
			ctrl.lmDone({result: box});
		};
		
		ctrl.ok = function() {
			if('NEWS' == ctrl.box.type) ctrl.createNewsBox();
			if('BOOKMARKS' == ctrl.box.type) ctrl.createBookmarkBox();
			if('TODO' == ctrl.box.type) ctrl.createTodoBox();
			if('NOTE' == ctrl.box.type) ctrl.createNoteBox();
			if('IOT' == ctrl.box.type) ctrl.createThingsBox();
		};
  }
});
