/*
 * Params:
 * id: note id (required)
 */
lm.component('lmDialogNoteEdit', {
	templateUrl: 'comp/dialog/lmDialogNoteEdit.' + lmCacheTag + 'html',
	bindings: { lmParams: '<', lmDismiss: '&', lmDone: '&' },
	controller: function($http, serviceLimboMedia) {
		var ctrl = this;

		ctrl.item = null;
		ctrl.labels = [];
		
		ctrl.$onInit = function() {
			/* load item */
			$http.get(lmBase.url + 'n/item/' + ctrl.lmParams.id).then(
					function success(resp) {
						ctrl.item = resp.data;
					},
					serviceLimboMedia.handleHttpErrorNew
			);
			
			/* load labels for selection */
			$http.get(lmBase.url + 'n/labels/writeable').then(
					function success(resp) {
						ctrl.labels = resp.data;
					},
					serviceLimboMedia.handleHttpErrorNew
			);			
		};
		
		ctrl.ok = function() {
			var req = {name: ctrl.item.name, content: ctrl.item.content, labelId: ctrl.item.label.id};
			$http.post(lmBase.url + 'n/item/' + ctrl.item.id, req).then(
				function success(resp) {
					ctrl.lmDone();
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};		
	}
});
