lm.component('lmPdfPage', {
  templateUrl: 'comp/generic/lmPdfPage.' + lmCacheTag + 'html',
  bindings: {
	  model: '<',
	  scale: '<'
  },
  controller: function($scope, $element, $http, $translate, serviceLimboMedia, serviceNotification, serviceDeps) {
	  var ctrl = this;
	  
	  ctrl.canvas = $element[0].getElementsByClassName('pdfcanvas')[0];
	  ctrl.canvasContext = ctrl.canvas.getContext('2d');
	  
	  ctrl.renderTask = null;
	  
	  ctrl.$onInit = function() {
	  };
	  
	  ctrl.$postLink = function() {
	  };
	  
	  ctrl.render = function() {
		  if(!ctrl.model) {
			  console.log("Clearing");
			  return;
		  }
		  
		  var ww = window.innerWidth;
		  
		  var viewportOriginal = ctrl.model.getViewport(1);
		  var viewportTarget = null;
		  
		  if(!ctrl.scale || ctrl.scale == 'SCALE_ORIGINAL') {
			  viewportTarget = viewportOriginal;
		  }
		  else if(ctrl.scale == 'SCALE_FULL') {
			  var targetWidth = ww - 50;
			  var targetScale = targetWidth / viewportOriginal.width;
			  viewportTarget = ctrl.model.getViewport(targetScale);
		  }
		  else if(ctrl.scale == 'SCALE_DEFAULT') {
			  var targetWidth = ww > 1000 ? 900 : ww - 50;
			  var targetScale = targetWidth / viewportOriginal.width;
			  viewportTarget = ctrl.model.getViewport(targetScale);
		  }
		  
		  // Prepare canvas using PDF page dimensions
		  ctrl.canvas.height = viewportTarget.height;
		  ctrl.canvas.width = viewportTarget.width;
		  
		  // Render PDF page into canvas context
		  var renderContext = {canvasContext: ctrl.canvasContext, viewport: viewportTarget};
		  
		  if(ctrl.renderTask) {
			  ctrl.renderTask.then(function() {
				  ctrl.renderTask = ctrl.model.render(renderContext);  
			  });
		  }
		  else {
			  ctrl.renderTask = ctrl.model.render(renderContext);
		  }

		  ctrl.renderTask.then(function () {
			  // console.log('Page rendered');
		  });
	  };
	  
	  ctrl.$onChanges = function(cobj) {
		  if(cobj.model) {
			  ctrl.render();
		  }
		  if(cobj.scale) {
			  ctrl.render();
		  }
	  };
  }
});
