lm.component('pageHome', {
  templateUrl: 'comp/page/pageHome.' + lmCacheTag + 'html',
  bindings: {},
  $canActivate: function($nextInstruction, $prevInstruction, serviceLimboMedia) {
	  return serviceLimboMedia.isAuthenticated();
  },
  controller: function(serviceLimboMedia, serviceModal) {

	  var ctrl = this;
	  ctrl.settings = null;
	  ctrl.boxes = [];
	  
	  /* box changing */
	  ctrl.boxUp = function(valueBox) {
			var idx = ctrl.boxes.indexOf(valueBox);
			if(idx < 1) return;
			var tmp = ctrl.boxes[idx];
			ctrl.boxes[idx] = ctrl.boxes[idx - 1];
			ctrl.boxes[idx - 1] = tmp;
			ctrl.stateSave();
		}

	  ctrl.boxDown = function(valueBox) {
			var idx = ctrl.boxes.indexOf(valueBox);
			if(idx >= (ctrl.boxes.length - 1)) return;
			var tmp = ctrl.boxes[idx];
			ctrl.boxes[idx] = ctrl.boxes[idx + 1];
			ctrl.boxes[idx + 1] = tmp;
			ctrl.stateSave();
		}

	  ctrl.boxDelete = function(valueBox) {
			var idx = ctrl.boxes.indexOf(valueBox);
			ctrl.boxes.splice(idx,1);
			ctrl.stateSave();
	  }
	  
	  ctrl.boxNew = function() {
		  serviceModal.show('lm-dialog-homebox').then(
			  function(result) {
				  if(result) {
					  ctrl.boxes.push(result);
					  ctrl.stateSave();
				  }
			  },
			  function() { }
		  );
	  }
	  
	  /* settings */
	  ctrl.stateSave = function() {
		  serviceLimboMedia.saveRemoteSettings();
	  }
	  
	  ctrl.init = function() {
		  ctrl.settings = serviceLimboMedia.getRemoteSettings();
		  if(ctrl.settings.boxes == null) {
			  ctrl.settings.boxes = [];
			  ctrl.boxes = ctrl.settings.boxes;

			  var box = {
				  type: 'newsBox',
				  name: 'LimboMedia News'
			  }
			  ctrl.boxes.push(box);
		  }
		  else {
			  ctrl.boxes = ctrl.settings.boxes;
		  }
	  }
	  
	  ctrl.init();
  }
});