lm.component('pageTodo', {
  templateUrl: 'comp/page/pageTodo.' + lmCacheTag + 'html',
  bindings: {
  },
  $canActivate: function($nextInstruction, $prevInstruction, serviceLimboMedia) {
	  return serviceLimboMedia.isAuthenticated();
  },
  controller: function($http, serviceLimboMedia) {
	  var ctrl = this;
	  
	  ctrl.search = {active: false, value: ''};
	  ctrl.predicate = 'NAME';
	  ctrl.dir = 'asc';
	  ctrl.pageSizes = [10,20,50,100,200,500,1000,100000];

	  /* LabelWithTodos in normal view */
	  ctrl.itemsAIO = [];
	  
	  /* Todos in search view */
	  ctrl.itemsSearch = [];

	  ctrl.clearItems = function() {
		  ctrl.itemsAIO = [];
		  ctrl.itemsSearch = [];
	  }

	  ctrl.loadItems = function() {
		  ctrl.clearItems();
			
			if(ctrl.search.active) {
				var getparams = new Object();
				getparams.order = ctrl.predicate;
				getparams.dir = ctrl.dir;
				getparams.s = ctrl.search.value;
				
				$http.get(lmBase.url + 't/items/search',{params : getparams}).then(
					function success(resp) {
						ctrl.itemsSearch = resp.data;
					},
					serviceLimboMedia.handleHttpErrorNew
				);
			}
			else {
				$http.get(lmBase.url + 't/items/allWithLabel').then(
					function success(resp) {
						ctrl.itemsAIO = resp.data;
					},
					serviceLimboMedia.handleHttpErrorNew
				);
			}
		};
		
		ctrl.changeOrder = function(valueOrder) {
			if(ctrl.predicate == valueOrder) {
				ctrl.dir = ctrl.dir == 'asc' ? 'desc' : 'asc';
			}
			else {
				ctrl.dir = 'asc';
				ctrl.predicate = valueOrder;
			}
			ctrl.loadItems();
		};
		
		/* label stuff */
		ctrl.inputLabelCreate = '';

		ctrl.labelCreate = function() {
			$http.post(lmBase.url + 't/label',{name: ctrl.inputLabelCreate}).then(
				function success(resp) {
					ctrl.inputLabelCreate = '';
					ctrl.loadItems();
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};

		ctrl.labelOnChange = function(labelWithItems) {
			/* reload all because item could've been moved to another box */
			ctrl.loadItems();
		};
		
		/* todo stuff */
		ctrl.itemCreate = function(valueLabel, valueName) {
			$http.post(lmBase.url + 't/item',{name: valueName, labelId: valueLabel.id}).then(
				function success(resp) {
					ctrl.loadItems();
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};


		/* SETTINGS (not atm) */
		ctrl.settings = {};
		ctrl.loadItems();
		
  }
});