lm.component('lmUiPopper', {
  templateUrl: 'comp/ui/lmUiPopper.' + lmCacheTag + 'html',
  bindings: {
	  lmOutside: '<',		// Catch close events here. Defaults to document. Use for modals, etc.
	  lmPopPlace: '@',		// Placement, default bottom-end, check popper.js docs for valid values
	  lmPopFlip: '@'		// Flip if no space. Defaults to true.
  },
  transclude: {
      'slotTrigger': '?lmUixTrigger',
      'slotContent': 'lmUixContent'
  },
  controller: function($scope, $element, $http, $translate, $timeout, serviceLimboMedia, serviceNotification, serviceDeps) {
	  var ctrl = this;

	  ctrl.render = false;
	  ctrl.popper = null;
	  ctrl.listener = false;
	  
	  ctrl.$onInit = function() {
		  ctrl.lmPopPlace = ctrl.lmPopPlace || 'bottom-end';
		  ctrl.lmOutside = ctrl.lmOutside || document;
		  ctrl.lmPopFlip = ctrl.lmPopFlip ? "true" == ctrl.lmPopFlip : true;
	  };
	  
	  ctrl.intListenerAdd = function() {
		  if(!ctrl.listener) {
			  ctrl.lmOutside.addEventListener('click', ctrl.clickAnywhere);
			  ctrl.listener = true;
		  }
	  };
	  ctrl.intListenerRemove = function() {
		  if(ctrl.listener) {
			  ctrl.lmOutside.removeEventListener('click', ctrl.clickAnywhere);
			  ctrl.listener = false;
		  }
	  };
	  ctrl.intPopperInit = function() {
		  // initialize or update popper
		  if(ctrl.popper) {
			  ctrl.popper.scheduleUpdate();
		  }
		  else {
			  var elTrigger = $element.find('lm-uix-trigger').get(0);
			  var elContent = $element.find('.contentWrapper').get(0);
			  
			  ctrl.popper = new Popper(elTrigger, elContent, {
				  placement: ctrl.lmPopPlace,
				  modifiers: {
					  // Disabling makes placing way more reliable, especially in fullscreen 
					  preventOverflow: { enabled: false },
					  // Hide makes only sense for tooltips and hovers. BTW requires preventOverflow.
					  hide: { enabled: false },
					  flip: { enabled: !ctrl.lmPopFlip }
				  }
			  });			  
		  }
	  };

	  ctrl.clickTrigger = function($event) {
		  if(!ctrl.render) {
			  ctrl.render = true;
			  // trigger show in next cycle to catch same event for instant close. 
			  $timeout(function() {
				  ctrl.intPopperInit();
				  ctrl.intListenerAdd();
			  });
		  }
	  };
	  
	  ctrl.clickAnywhere = function($event) {
	  	  /* prevent closing popper if element or parent has class 'noclose'. */
		  var elNoClose = $event.target.closest('.noclose');
		  
		  if(ctrl.render && !!!elNoClose) {
			  $scope.$apply(function() {
				  ctrl.render = false;
				  ctrl.intListenerRemove();
			  });
		  }
	  };
	  
	  ctrl.$onDestroy = function() {
		  ctrl.intListenerRemove(); 
		  if(ctrl.popper) {
			  ctrl.popper.destroy();
		  }
	  };

  }
});
