lm.filter('lmDate', function() {
	return function(input, uppercase) {
		input = input || '';
	    return lmBase.timestampToDate(input);
	};
});

lm.filter('lmDateTime', function() {
	return function(input, uppercase) {
		input = input || '';
	    return lmBase.timestampToDateTime(input);
	};
});
lm.filter('lmSize', function() {
	return function(input, uppercase) {
		input = input || '';
	    return lmBase.niceSize(input);
	};
});
lm.filter('lmDuration', function() {
	return function(input, uppercase) {
		input = input || '';
	    return lmBase.secondsToString(input);
	};
});

lm.filter('lmAudioCover', function() {
	return function(input, uppercase) {
		if(input == null || !input.cover) {
			return 'img/logo_bigbig.png';
		}
		else {
			return lmBase.url + 'f/streamImage/' + input.id + '/THUMB_L/' + encodeURIComponent(input.name);
		}
	};
});

lm.filter('lmTypeFont', function() {
	return function(input, uppercase) {
		var result = lmBase.filetypefontmapping[input.type];
		return result ? result : 'icon-file'; 
	};
});

lm.filter('lmImageLink', function() {
	return function(input, layout) {
		if(input == null || !input.cover) {
			return '';
		}
		else {
			return lmBase.url + 'f/streamImage/' + input.id + '/' + layout + '/' + encodeURIComponent(input.name);
		}
	};
});

lm.filter('lmIsFilePdf', function() {
	return function(input) {
		return lmBase.isFilePdf(input);
	};
});

lm.filter('lmIsFileText', function() {
	return function(input) {
		return lmBase.isFileText(input);
	};
});

lm.filter('lmRound', function() {
	return function(input) {
		return Math.round(input);
	};
});

lm.filter('lmOrder', function() {
	return function(input,currentOrder,currentDir) {
		if(input != currentOrder) return '';
		return 'asc' == currentDir ? '↓' : '↑';
	};
});
